package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public static class _nameandmac{
public boolean IsInitialized;
public String Name;
public String Mac;
public void Initialize() {
IsInitialized = true;
Name = "";
Mac = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _admin = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public static anywheresoftware.b4a.objects.collections.List _founddevices = null;
public static b4a.example.main._nameandmac _connecteddevice = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnsearchfordevices = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnallowconnection = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox1 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox2 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox3 = null;
public anywheresoftware.b4a.objects.HorizontalScrollViewWrapper _horizontalscrollview1 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox10 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox4 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox5 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox6 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox7 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox8 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox9 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox11 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox13 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox14 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox15 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox16 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox17 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox18 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox19 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox20 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox21 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox22 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox12 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _avancarsbt = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkbox23 = null;
public anywheresoftware.b4a.objects.ImageViewWrapper _imageview1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 62;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 65;BA.debugLine="Msgbox(\"Obrigado por experimentar este programa.                       Com ele podemos comunicar com o Arduino Nano v3 atravez do Bluetooth\", \"Arduino NANO V3 BT\")";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.Msgbox("Obrigado por experimentar este programa.                       Com ele podemos comunicar com o Arduino Nano v3 atravez do Bluetooth","Arduino NANO V3 BT",mostCurrent.activityBA);
 BA.debugLineNum = 66;BA.debugLine="If FirstTime Then";
Debug.ShouldStop(2);
if (_firsttime) { 
 BA.debugLineNum = 67;BA.debugLine="admin.Initialize(\"admin\")";
Debug.ShouldStop(4);
_admin.Initialize(processBA,"admin");
 BA.debugLineNum = 68;BA.debugLine="serial1.Initialize(\"serial1\")";
Debug.ShouldStop(8);
Debug.DebugWarningEngine.CheckInitialize(_serial1);_serial1.Initialize("serial1");
 };
 BA.debugLineNum = 70;BA.debugLine="Activity.LoadLayout(\"1\")";
Debug.ShouldStop(32);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 71;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 93;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 94;BA.debugLine="If UserClosed = True Then";
Debug.ShouldStop(536870912);
if (_userclosed==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 95;BA.debugLine="serial1.Disconnect";
Debug.ShouldStop(1073741824);
_serial1.Disconnect();
 };
 BA.debugLineNum = 97;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 73;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(256);
 BA.debugLineNum = 74;BA.debugLine="btnSearchForDevices.Enabled = False";
Debug.ShouldStop(512);
mostCurrent._btnsearchfordevices.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 75;BA.debugLine="btnAllowConnection.Enabled = False";
Debug.ShouldStop(1024);
mostCurrent._btnallowconnection.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 76;BA.debugLine="If admin.IsEnabled = False Then";
Debug.ShouldStop(2048);
if (_admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 77;BA.debugLine="If admin.Enable = False Then";
Debug.ShouldStop(4096);
if (_admin.Enable()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 78;BA.debugLine="ToastMessageShow(\"Error enabling Bluetooth adapter.\", True)";
Debug.ShouldStop(8192);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error enabling Bluetooth adapter.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 80;BA.debugLine="ToastMessageShow(\"Enabling Bluetooth adapter...\", False)";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Enabling Bluetooth adapter...",anywheresoftware.b4a.keywords.Common.False);
 };
 }else {
 BA.debugLineNum = 84;BA.debugLine="Admin_StateChanged(admin.STATE_ON, 0)";
Debug.ShouldStop(524288);
_admin_statechanged(_admin.STATE_ON,(int)(0));
 };
 BA.debugLineNum = 86;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _admin_devicefound(String _name,String _macaddress) throws Exception{
		Debug.PushSubsStack("Admin_DeviceFound (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
b4a.example.main._nameandmac _nm = null;
Debug.locals.put("Name", _name);
Debug.locals.put("MacAddress", _macaddress);
 BA.debugLineNum = 130;BA.debugLine="Sub Admin_DeviceFound (Name As String, MacAddress As String)";
Debug.ShouldStop(2);
 BA.debugLineNum = 131;BA.debugLine="Log(Name & \":\" & MacAddress)";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.Log(_name+":"+_macaddress);
 BA.debugLineNum = 132;BA.debugLine="Dim nm As NameAndMac";
Debug.ShouldStop(8);
_nm = new b4a.example.main._nameandmac();Debug.locals.put("nm", _nm);
 BA.debugLineNum = 133;BA.debugLine="nm.Name = Name";
Debug.ShouldStop(16);
_nm.Name = _name;Debug.locals.put("nm", _nm);
 BA.debugLineNum = 134;BA.debugLine="nm.Mac = MacAddress";
Debug.ShouldStop(32);
_nm.Mac = _macaddress;Debug.locals.put("nm", _nm);
 BA.debugLineNum = 135;BA.debugLine="foundDevices.Add(nm)";
Debug.ShouldStop(64);
_founddevices.Add((Object)(_nm));
 BA.debugLineNum = 136;BA.debugLine="ProgressDialogShow(\"Searching for devices (~ device found)...\".Replace(\"~\", foundDevices.Size))";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Searching for devices (~ device found)...".replace("~",BA.NumberToString(_founddevices.getSize())));
 BA.debugLineNum = 137;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _admin_discoveryfinished() throws Exception{
		Debug.PushSubsStack("Admin_DiscoveryFinished (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
b4a.example.main._nameandmac _nm = null;
int _res = 0;
 BA.debugLineNum = 108;BA.debugLine="Sub Admin_DiscoveryFinished";
Debug.ShouldStop(2048);
 BA.debugLineNum = 109;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(4096);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 BA.debugLineNum = 110;BA.debugLine="If foundDevices.Size = 0 Then";
Debug.ShouldStop(8192);
if (_founddevices.getSize()==0) { 
 BA.debugLineNum = 111;BA.debugLine="ToastMessageShow(\"No device found.\", True)";
Debug.ShouldStop(16384);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("No device found.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 113;BA.debugLine="Dim l As List";
Debug.ShouldStop(65536);
_l = new anywheresoftware.b4a.objects.collections.List();Debug.locals.put("l", _l);
 BA.debugLineNum = 114;BA.debugLine="l.Initialize";
Debug.ShouldStop(131072);
_l.Initialize();
 BA.debugLineNum = 115;BA.debugLine="For i = 0 To foundDevices.Size - 1";
Debug.ShouldStop(262144);
{
final double step86 = 1;
final double limit86 = (int)(_founddevices.getSize()-1);
for (_i = (int)(0); (step86 > 0 && _i <= limit86) || (step86 < 0 && _i >= limit86); _i += step86) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 116;BA.debugLine="Dim nm As NameAndMac";
Debug.ShouldStop(524288);
_nm = new b4a.example.main._nameandmac();Debug.locals.put("nm", _nm);
 BA.debugLineNum = 117;BA.debugLine="nm = foundDevices.Get(i)";
Debug.ShouldStop(1048576);
_nm = (b4a.example.main._nameandmac)(_founddevices.Get(_i));Debug.locals.put("nm", _nm);
 BA.debugLineNum = 118;BA.debugLine="l.Add(nm.Name)";
Debug.ShouldStop(2097152);
_l.Add((Object)(_nm.Name));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 120;BA.debugLine="Dim res As Int";
Debug.ShouldStop(8388608);
_res = 0;Debug.locals.put("res", _res);
 BA.debugLineNum = 121;BA.debugLine="res = InputList(l, \"Choose device to connect\", -1)";
Debug.ShouldStop(16777216);
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Choose device to connect",(int)(-1),mostCurrent.activityBA);Debug.locals.put("res", _res);
 BA.debugLineNum = 122;BA.debugLine="If res <> DialogResponse.CANCEL Then";
Debug.ShouldStop(33554432);
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 BA.debugLineNum = 123;BA.debugLine="connectedDevice = foundDevices.Get(res)";
Debug.ShouldStop(67108864);
_connecteddevice = (b4a.example.main._nameandmac)(_founddevices.Get(_res));
 BA.debugLineNum = 124;BA.debugLine="ProgressDialogShow(\"Trying to connect to: \" & connectedDevice.Name & \" (\" & connectedDevice.Mac & \")\")";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Trying to connect to: "+_connecteddevice.Name+" ("+_connecteddevice.Mac+")");
 BA.debugLineNum = 125;BA.debugLine="serial1.Connect(connectedDevice.Mac)";
Debug.ShouldStop(268435456);
_serial1.Connect(processBA,_connecteddevice.Mac);
 };
 };
 BA.debugLineNum = 128;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _admin_statechanged(int _newstate,int _oldstate) throws Exception{
		Debug.PushSubsStack("Admin_StateChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("NewState", _newstate);
Debug.locals.put("OldState", _oldstate);
 BA.debugLineNum = 88;BA.debugLine="Sub Admin_StateChanged (NewState As Int, OldState As Int)";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 89;BA.debugLine="btnSearchForDevices.Enabled = (NewState = admin.STATE_ON)";
Debug.ShouldStop(16777216);
mostCurrent._btnsearchfordevices.setEnabled((_newstate==_admin.STATE_ON));
 BA.debugLineNum = 90;BA.debugLine="btnAllowConnection.Enabled = btnSearchForDevices.Enabled";
Debug.ShouldStop(33554432);
mostCurrent._btnallowconnection.setEnabled(mostCurrent._btnsearchfordevices.getEnabled());
 BA.debugLineNum = 91;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _avancarsbt_click() throws Exception{
		Debug.PushSubsStack("avancarsbt_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 161;BA.debugLine="Sub avancarsbt_Click";
Debug.ShouldStop(1);
 BA.debugLineNum = 162;BA.debugLine="Activity.LoadLayout(\"2\")";
Debug.ShouldStop(2);
mostCurrent._activity.LoadLayout("2",mostCurrent.activityBA);
 BA.debugLineNum = 164;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnallowconnection_click() throws Exception{
		Debug.PushSubsStack("btnAllowConnection_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.IntentWrapper _i = null;
 BA.debugLineNum = 139;BA.debugLine="Sub btnAllowConnection_Click";
Debug.ShouldStop(1024);
 BA.debugLineNum = 141;BA.debugLine="Dim i As Intent";
Debug.ShouldStop(4096);
_i = new anywheresoftware.b4a.objects.IntentWrapper();Debug.locals.put("i", _i);
 BA.debugLineNum = 142;BA.debugLine="i.Initialize(\"android.bluetooth.adapter.action.REQUEST_DISCOVERABLE\", \"\")";
Debug.ShouldStop(8192);
_i.Initialize("android.bluetooth.adapter.action.REQUEST_DISCOVERABLE","");
 BA.debugLineNum = 143;BA.debugLine="i.PutExtra(\"android.bluetooth.adapter.extra.DISCOVERABLE_DURATION\", 300)";
Debug.ShouldStop(16384);
_i.PutExtra("android.bluetooth.adapter.extra.DISCOVERABLE_DURATION",(Object)(300));
 BA.debugLineNum = 144;BA.debugLine="StartActivity(i)";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(_i.getObject()));
 BA.debugLineNum = 146;BA.debugLine="serial1.Listen";
Debug.ShouldStop(131072);
_serial1.Listen(processBA);
 BA.debugLineNum = 147;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnsearchfordevices_click() throws Exception{
		Debug.PushSubsStack("btnSearchForDevices_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 99;BA.debugLine="Sub btnSearchForDevices_Click";
Debug.ShouldStop(4);
 BA.debugLineNum = 100;BA.debugLine="foundDevices.Initialize";
Debug.ShouldStop(8);
_founddevices.Initialize();
 BA.debugLineNum = 101;BA.debugLine="If admin.StartDiscovery	= False Then";
Debug.ShouldStop(16);
if (_admin.StartDiscovery()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 102;BA.debugLine="ToastMessageShow(\"Error starting discovery process.\", True)";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error starting discovery process.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 104;BA.debugLine="ProgressDialogShow(\"Searching for devices...\")";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Searching for devices...");
 };
 BA.debugLineNum = 106;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox0_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox0_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 178;BA.debugLine="Sub CheckBox0_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(131072);
 BA.debugLineNum = 180;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox1_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox1_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 182;BA.debugLine="Sub CheckBox1_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 184;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox10_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox10_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 218;BA.debugLine="Sub CheckBox10_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 220;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox11_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox11_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 222;BA.debugLine="Sub CheckBox11_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 224;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox12_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox12_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 226;BA.debugLine="Sub CheckBox12_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(2);
 BA.debugLineNum = 228;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox13_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox13_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 230;BA.debugLine="Sub CheckBox13_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(32);
 BA.debugLineNum = 231;BA.debugLine="If Checked = True Then";
Debug.ShouldStop(64);
if (_checked==anywheresoftware.b4a.keywords.Common.True) { 
 }else {
 };
 BA.debugLineNum = 236;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox14_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox14_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 238;BA.debugLine="Sub CheckBox14_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(8192);
 BA.debugLineNum = 240;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox15_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox15_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 241;BA.debugLine="Sub CheckBox15_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(65536);
 BA.debugLineNum = 243;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox16_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox16_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 245;BA.debugLine="Sub CheckBox16_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 247;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox17_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox17_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 249;BA.debugLine="Sub CheckBox17_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 251;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox18_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox18_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 253;BA.debugLine="Sub CheckBox18_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 255;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox19_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox19_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 257;BA.debugLine="Sub CheckBox19_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(1);
 BA.debugLineNum = 259;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox2_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox2_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 186;BA.debugLine="Sub CheckBox2_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 188;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox20_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox20_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 261;BA.debugLine="Sub CheckBox20_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(16);
 BA.debugLineNum = 263;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox21_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox21_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 265;BA.debugLine="Sub CheckBox21_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(256);
 BA.debugLineNum = 267;BA.debugLine="End Sub";
Debug.ShouldStop(1024);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox23_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox23_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 166;BA.debugLine="Sub CheckBox23_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(32);
 BA.debugLineNum = 167;BA.debugLine="Activity.LoadLayout(\"1\")";
Debug.ShouldStop(64);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 168;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox3_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox3_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 190;BA.debugLine="Sub CheckBox3_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 192;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox4_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox4_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 194;BA.debugLine="Sub CheckBox4_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(2);
 BA.debugLineNum = 196;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox5_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox5_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 198;BA.debugLine="Sub CheckBox5_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(32);
 BA.debugLineNum = 200;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox6_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox6_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 202;BA.debugLine="Sub CheckBox6_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(512);
 BA.debugLineNum = 204;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox7_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox7_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 206;BA.debugLine="Sub CheckBox7_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(8192);
 BA.debugLineNum = 208;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox8_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox8_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 210;BA.debugLine="Sub CheckBox8_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(131072);
 BA.debugLineNum = 212;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _checkbox9_checkedchange(boolean _checked) throws Exception{
		Debug.PushSubsStack("CheckBox9_CheckedChange (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Checked", _checked);
 BA.debugLineNum = 214;BA.debugLine="Sub CheckBox9_CheckedChange(Checked As Boolean)";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 216;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 17462, new int[] {9}, "1411020f-1260-44ff-ad32-d4a03ea50d2b");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 29;BA.debugLine="Dim btnSearchForDevices As Button";
mostCurrent._btnsearchfordevices = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Dim btnAllowConnection As Button";
mostCurrent._btnallowconnection = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Dim Button2 As Button";
mostCurrent._button2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Dim CheckBox1 As CheckBox";
mostCurrent._checkbox1 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Dim CheckBox2 As CheckBox";
mostCurrent._checkbox2 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 35;BA.debugLine="Dim CheckBox3 As CheckBox";
mostCurrent._checkbox3 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Dim HorizontalScrollView1 As HorizontalScrollView";
mostCurrent._horizontalscrollview1 = new anywheresoftware.b4a.objects.HorizontalScrollViewWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Dim CheckBox10 As CheckBox";
mostCurrent._checkbox10 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Dim CheckBox4 As CheckBox";
mostCurrent._checkbox4 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 39;BA.debugLine="Dim CheckBox5 As CheckBox";
mostCurrent._checkbox5 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim CheckBox6 As CheckBox";
mostCurrent._checkbox6 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Dim CheckBox7 As CheckBox";
mostCurrent._checkbox7 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Dim CheckBox8 As CheckBox";
mostCurrent._checkbox8 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Dim CheckBox9 As CheckBox";
mostCurrent._checkbox9 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Dim EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Dim CheckBox11 As CheckBox";
mostCurrent._checkbox11 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Dim CheckBox13 As CheckBox";
mostCurrent._checkbox13 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Dim CheckBox14 As CheckBox";
mostCurrent._checkbox14 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Dim CheckBox15 As CheckBox";
mostCurrent._checkbox15 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Dim CheckBox16 As CheckBox";
mostCurrent._checkbox16 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 50;BA.debugLine="Dim CheckBox17 As CheckBox";
mostCurrent._checkbox17 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 51;BA.debugLine="Dim CheckBox18 As CheckBox";
mostCurrent._checkbox18 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 52;BA.debugLine="Dim CheckBox19 As CheckBox";
mostCurrent._checkbox19 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 53;BA.debugLine="Dim CheckBox20 As CheckBox";
mostCurrent._checkbox20 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 54;BA.debugLine="Dim CheckBox21 As CheckBox";
mostCurrent._checkbox21 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 55;BA.debugLine="Dim CheckBox22 As CheckBox";
mostCurrent._checkbox22 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 56;BA.debugLine="Dim CheckBox12 As CheckBox";
mostCurrent._checkbox12 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 57;BA.debugLine="Dim avancarsbt As Button";
mostCurrent._avancarsbt = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 58;BA.debugLine="Dim CheckBox23 As CheckBox";
mostCurrent._checkbox23 = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 59;BA.debugLine="Dim ImageView1 As ImageView";
mostCurrent._imageview1 = new anywheresoftware.b4a.objects.ImageViewWrapper();
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}
public static String  _imageview1_click() throws Exception{
		Debug.PushSubsStack("ImageView1_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 170;BA.debugLine="Sub ImageView1_Click";
Debug.ShouldStop(512);
 BA.debugLineNum = 172;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _imageview1_longclick() throws Exception{
		Debug.PushSubsStack("ImageView1_LongClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 174;BA.debugLine="Sub ImageView1_LongClick";
Debug.ShouldStop(8192);
 BA.debugLineNum = 176;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim admin As BluetoothAdmin";
_admin = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 19;BA.debugLine="Dim timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 20;BA.debugLine="Dim serial1 As Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 21;BA.debugLine="Dim foundDevices As List";
_founddevices = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 22;BA.debugLine="Type NameAndMac (Name As String, Mac As String)";
;
 //BA.debugLineNum = 23;BA.debugLine="Dim connectedDevice As NameAndMac";
_connecteddevice = new b4a.example.main._nameandmac();
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
		Debug.PushSubsStack("Serial1_Connected (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Success", _success);
 BA.debugLineNum = 149;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 150;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 BA.debugLineNum = 151;BA.debugLine="Log(\"connected: \" & Success)";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.Log("connected: "+String.valueOf(_success));
 BA.debugLineNum = 152;BA.debugLine="If Success = False Then";
Debug.ShouldStop(8388608);
if (_success==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 153;BA.debugLine="Log(LastException.Message)";
Debug.ShouldStop(16777216);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage());
 BA.debugLineNum = 154;BA.debugLine="ToastMessageShow(\"Error connecting: \" & LastException.Message, True)";
Debug.ShouldStop(33554432);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error connecting: "+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),anywheresoftware.b4a.keywords.Common.True);
 }else {
 };
 BA.debugLineNum = 159;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"admin",_admin,"timer1",_timer1,"serial1",_serial1,"foundDevices",_founddevices,"connectedDevice",_connecteddevice,"btnSearchForDevices",_btnsearchfordevices,"btnAllowConnection",_btnallowconnection,"Button1",_button1,"Button2",_button2,"CheckBox1",_checkbox1,"CheckBox2",_checkbox2,"CheckBox3",_checkbox3,"HorizontalScrollView1",_horizontalscrollview1,"CheckBox10",_checkbox10,"CheckBox4",_checkbox4,"CheckBox5",_checkbox5,"CheckBox6",_checkbox6,"CheckBox7",_checkbox7,"CheckBox8",_checkbox8,"CheckBox9",_checkbox9,"EditText1",_edittext1,"CheckBox11",_checkbox11,"CheckBox13",_checkbox13,"CheckBox14",_checkbox14,"CheckBox15",_checkbox15,"CheckBox16",_checkbox16,"CheckBox17",_checkbox17,"CheckBox18",_checkbox18,"CheckBox19",_checkbox19,"CheckBox20",_checkbox20,"CheckBox21",_checkbox21,"CheckBox22",_checkbox22,"CheckBox12",_checkbox12,"avancarsbt",_avancarsbt,"CheckBox23",_checkbox23,"ImageView1",_imageview1};
}
}
